#ifndef __SYSCONF_H__
#define __SYSCONF_H__

#define INDICATE_LEFT      (1 << 0)
#define INDICATE_RIGHT     (1 << 1)
#define INDICATE_A__Z      (1 << 2)
#define INDICATE_a__z      (1 << 3)
#define INDICATE_BUSY      (1 << 4)
#define INDICATE_TX        (1 << 5)
#define INDICATE_RX        (1 << 6)

#define RAM_BASE    (0x02000000)
#define RAM_SIZE    (3 * 1048576)

#define FS_FATFS        0
#define FS_LITTLEFS     1
#define FS_TYPE         FS_FATFS

#define VM_RAM_SIZE_NONE_FTL 0 // 51*1024, does not work
#if VM_RAM_SIZE_NONE_FTL==0
  #define IRQ_STACK_ADDR      (RAM_BASE + RAM_SIZE - 8)
  #define SWI_STACK_ADDR      (IRQ_STACK_ADDR     - 100 * 4)
  #define NORMAL_STACK_ADDR   (SWI_STACK_ADDR - 100 * 4)
  #define KERNEL_HEAP_END     (NORMAL_STACK_ADDR  - 1024*24)
#else
  #define NORMAL_STACK_ADDR   (RAM_BASE + VM_RAM_SIZE_NONE_FTL - 8)
  #define IRQ_STACK_ADDR      (NORMAL_STACK_ADDR  - 100 * 4)
  #define SWI_STACK_ADDR      (IRQ_STACK_ADDR     - 100 * 4)
  #define KERNEL_HEAP_END     (RAM_BASE + RAM_SIZE - 8)
#endif

#endif
